# To contribute improvements to CI/CD templates, please follow the Development guide at:
# https://docs.gitlab.com/ee/development/cicd/templates.html
#
# Maintainer: Gabriel Nigro Garbelini (gabriel.garbelini@odontoprev.com.br)
#
# Use this template to enable container scanning in your project.
#
# How to use:
# You should add this template to an existing `.gitlab-ci.yml` file by using the `include:` keyword.
#
# Official framework image. Look for the different tagged releases at:
# https://hub.docker.com/r/aquasec/trivy/tags

variables:
  CONTAINER_SCANNING_IMAGE: aquasec/trivy:0.48.3

container-scanning:
  stage: test
  tags:
    - $RUNNER
  image:
    name: $CONTAINER_SCANNING_IMAGE
    entrypoint: [""]
  variables:
    # No need to clone the repo, we exclusively work on artifacts.  See
    # https://docs.gitlab.com/ee/ci/runners/README.html#git-strategy
    GIT_STRATEGY: none
    TRIVY_USERNAME: "$CI_REGISTRY_USER"
    TRIVY_PASSWORD: "$CI_REGISTRY_PASSWORD"
    TRIVY_AUTH_URL: "$CI_REGISTRY"
    TRIVY_NO_PROGRESS: "true"
    TRIVY_CACHE_DIR: ".trivycache/"
  script:
    - trivy --version
    # cache cleanup is needed when scanning images with the same tags, it does not remove the database
    - time trivy image --clear-cache
    # update vulnerabilities db
    - time trivy image --download-db-only
    # Builds report and puts it in the default workdir $CI_PROJECT_DIR, so `artifacts:` can take it from there
    - time trivy image
      --exit-code 0
      --format template
      --template "@/contrib/gitlab.tpl"
      --output "$CI_PROJECT_DIR/gl-container-scanning-report.json"
      "$IMAGE_NAME"
    # Prints full report
    - time trivy image --exit-code 0 "$IMAGE_NAME"
  cache:
    key: container_scanning
    paths:
      - .trivycache/
